{
===============================================================================
  Copyright (©) 2006. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 22-05-2006
  Versión actual: 1.0.0
  Fecha versión actual: 22-05-2006
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uEditorProcedenciasCliente;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, DBCtrls, uDADataTable, ActnList,
  uIEditorProcedenciasCliente, uEditorBasico, uGUIBase, ExtCtrls,
  ComCtrls, uBizProcedenciasCliente, uProcedenciasClienteController, uDAInterfaces,
  uEditorBase;

type
  TfEditorProcedenciasCliente = class(TfEditorBasico, IEditorProcedenciasCliente)
    ActionList1: TActionList;
    DADataSource: TDADataSource;
    ListaProcedenciasCliente: TDBLookupListBox;
    editProcedenciaCliente: TEdit;
    bAnadir: TButton;
    actAnadir: TAction;
    actEliminar: TAction;
    bEliminar: TButton;
    actAceptar: TAction;
    actCancelar: TAction;
    bAceptar: TButton;
    bCancelar: TButton;
    actCerrar: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    procedure FormShow(Sender: TObject);
    procedure CustomEditorClose(Sender: TObject; var Action: TCloseAction);

    procedure actAnadirExecute(Sender: TObject);
    procedure actEliminarExecute(Sender: TObject);
    procedure actAceptarExecute(Sender: TObject);
    procedure actCancelarExecute(Sender: TObject);
    procedure actCerrarExecute(Sender: TObject);
    procedure actAnadirUpdate(Sender: TObject);
    procedure actEliminarUpdate(Sender: TObject);
  protected
    FProcedenciasCliente: IBizProcedenciaCliente;
    FController: IProcedenciasClienteController;
    function GetProcedenciasCliente: IBizProcedenciaCliente;
    procedure SetProcedenciasCliente(const Value: IBizProcedenciaCliente);
    function GetController : IProcedenciasClienteController;
    procedure SetController (const Value : IProcedenciasClienteController);
  public
    property ProcedenciasCliente: IBizProcedenciaCliente read GetProcedenciasCliente write SetProcedenciasCliente;
    property Controller : IProcedenciasClienteController read GetController write SetController;
  end;


implementation
{$R *.dfm}

{ TfEditorProcedenciasCliente }

uses
  uDialogUtils;


function TfEditorProcedenciasCliente.GetController: IProcedenciasClienteController;
begin
  Result := FController;
end;

function TfEditorProcedenciasCliente.GetProcedenciasCliente: IBizProcedenciaCliente;
begin
  Result := FProcedenciasCliente;
end;

procedure TfEditorProcedenciasCliente.SetController(const Value: IProcedenciasClienteController);
begin
  FController := Value;
end;

procedure TfEditorProcedenciasCliente.SetProcedenciasCliente(const Value: IBizProcedenciaCliente);
begin
  FProcedenciasCliente := Value;
  DADataSource.DataTable := (FProcedenciasCliente as IBizProcedenciaCliente).DataTable;
  DADataSource.DataTable.Open;
end;

procedure TfEditorProcedenciasCliente.actAnadirExecute(Sender: TObject);
begin
  if not FController.Localizar(ProcedenciasCliente, editProcedenciaCliente.Text) then
  begin
    ProcedenciasCliente.Append;
    ProcedenciasCliente.DESCRIPCION := editProcedenciaCliente.Text;
    ProcedenciasCliente.Post;
    editProcedenciaCliente.Clear;
    ListaProcedenciasCliente.SetFocus;
  end
  else
    ShowErrorMessage('Ya existe la procedencia ' + editProcedenciaCliente.Text,
      'Ya existe la procedencia de cliente ''' + editProcedenciaCliente.Text + ''' en la lista.');
end;

procedure TfEditorProcedenciasCliente.actEliminarExecute(Sender: TObject);
begin
  ProcedenciasCliente.Delete;
  ListaProcedenciasCliente.SetFocus;
end;

procedure TfEditorProcedenciasCliente.actEliminarUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (FProcedenciasCliente.DataTable.RecordCount > 0) and
                                  (Length(ListaProcedenciasCliente.SelectedItem) > 0);

end;

procedure TfEditorProcedenciasCliente.CustomEditorClose(Sender: TObject; var Action: TCloseAction);
begin
  FProcedenciasCliente := Nil;
  FController := Nil;
end;

procedure TfEditorProcedenciasCliente.actAceptarExecute(Sender: TObject);
begin
  try
    ProcedenciasCliente.DataTable.ApplyUpdates;
  except
    on E : Exception do begin
      ProcedenciasCliente.DataTable.CancelUpdates;
      ShowErrorMessage('Error al guardar cambios', 'Se ha producido un error grave', E);
      exit;
    end;
  end;
  actCerrar.Execute;
end;

procedure TfEditorProcedenciasCliente.actCancelarExecute(Sender: TObject);
begin
  ProcedenciasCliente.DataTable.CancelUpdates;
  actCerrar.Execute;
end;

procedure TfEditorProcedenciasCliente.actCerrarExecute(Sender: TObject);
begin
  Close;
end;

procedure TfEditorProcedenciasCliente.actAnadirUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (Length(editProcedenciaCliente.Text) > 0)
end;

procedure TfEditorProcedenciasCliente.FormShow(Sender: TObject);
begin
  if not FProcedenciasCliente.DataTable.Active then
     FProcedenciasCliente.DataTable.Active := true;

  editProcedenciaCliente.SetFocus;
end;

end.
